//AB/ Project Sales Force
//AB/ Object prj is a View_Project
    //AB/ Set Size to 274 400
    //AB/ Set ProjectName to "Sales Force"
    //AB/ Set ProjectFileName to "JCREPS.vw"
    //AB/ Set GenerateFileName to "JCREPS.vw"

// Project Object Structure
//   JCREPS is a cPTDbView
//     Jcreps_DD is a DataDictionary
//     Container1 is a dbContainer3d
//       Jcreps_Idno is a cPTDbForm
//       Jcreps_Lastname is a cPTDbForm
//       Jcreps_Firstname is a dbForm
//       Jcreps_Mi is a dbForm
//       Jcreps_Count is a dbForm
//       Jcreps_Csr_Assigned is a dbForm
//     dbTabDialog1 is a dbTabDialog
//       TP_Address is a dbTabPage
//         Jcreps_Address_1 is a dbForm
//         Jcreps_Address_2 is a dbForm
//         Jcreps_City is a dbForm
//         Jcreps_State is a dbForm
//         Jcreps_Zip is a dbForm
//         Jcreps_Hm_Phone is a dbForm
//         Jcreps_Mo_Phone is a dbForm
//         oJcreps_Email is a cPTDbForm
//         Jcreps_Pg_Phone is a dbForm
//         oJcreps_Csr_Email is a cPTDbForm
//       TP_Personal is a dbTabPage
//         Jcreps_Ssn is a dbForm
//         Jcreps_Birth is a dbForm
//         Jcreps_Date_Hired is a dbForm
//         Jcreps_Salary is a dbForm
//         Jcreps_Commission is a dbForm
//         Jcreps_Payroll_Code is a dbForm

// Register all objects
Register_Object Container1
Register_Object dbTabDialog1
Register_Object JCREPS
Register_Object Jcreps_Address_1
Register_Object Jcreps_Address_2
Register_Object Jcreps_Birth
Register_Object Jcreps_City
Register_Object Jcreps_Commission
Register_Object Jcreps_Count
Register_Object Jcreps_Csr_Assigned
Register_Object Jcreps_Date_Hired
Register_Object Jcreps_DD
Register_Object Jcreps_Firstname
Register_Object Jcreps_Hm_Phone
Register_Object Jcreps_Idno
Register_Object Jcreps_Lastname
Register_Object Jcreps_Mi
Register_Object Jcreps_Mo_Phone
Register_Object Jcreps_Payroll_Code
Register_Object Jcreps_Pg_Phone
Register_Object Jcreps_Salary
Register_Object Jcreps_Ssn
Register_Object Jcreps_State
Register_Object Jcreps_Zip
Register_Object oJcreps_Csr_Email
Register_Object oJcreps_Email
Register_Object TP_Address
Register_Object TP_Personal

//AB-IgnoreStart
Use cPTDbView.pkg
Use DataDict.pkg
Use dfClient.pkg
Use cPTDbForm.pkg
Use dfEntry.pkg
Use dfTabDlg.pkg
//AB-IgnoreEnd

//AB-IgnoreStart
Use JCREPS.DD
Use Jcshst.DD
Use Windows.pkg
Use cPtButton.pkg
Use dfTable.pkg
//AB-IgnoreEnd

  //DISD BEGIN /////////////////////        
Use cDynamicAiReport.pkg //note to self: Did you remember to share the report in Dynamic AI?!
  //DISD End

ACTIVATE_VIEW Activate_JCREPS FOR JCREPS

Object JCREPS is a cPTDbView

    //AB-StoreTopStart
    property boolean pbReadOnly     FALSE
    property boolean pbAdmin        FALSE
    Property Boolean pbMgr          False    
    //AB-StoreTopEnd

    Set Label to "Sales Rep's"
    Set Location to 6 6
    // Visual DataFlex 14.0 Client Size Adjuster, modified May 23, 2008: 14:35:50
//    Set Size to 215 353
    Set Size to 274 477
    Set Border_Style to Border_Thick

    //AB-DDOStart

    Object Jcreps_DD is a Jcreps_DataDictionary

  ////DISD BEGIN /////////////////////        
        Procedure OnNewCurrentRecord RowID riOldRowId RowID riNewRowId
            Integer iTabPage
            Forward Send OnNewCurrentRecord riOldRowId riNewRowId
            Get Current_Tab of dbTabDialog1 to iTabpage
            If (iTabPage = 7) Begin 
                Send RunTheReport of oTop10_Intelligence        
            End
        End_Procedure
  ////DISD END ///////////////////////

    End_Object    // Jcreps_DD

    Object Jcshst_DD is a Jcshst_DataDictionary
        Set Constrain_file to Jcreps.File_number
        Set DDO_Server to Jcreps_DD
    End_Object

    Set Main_DD to Jcreps_DD
    Set Server to Jcreps_DD

    //AB-DDOEnd

    Object Container1 is a dbContainer3d
        Set Size to 72 340
        Set Location to 5 5
        Object Jcreps_Idno is a cPTDbForm
            Entry_Item Jcreps.Idno
            Set Label to "ID Number:"
            Set Size to 13 46
            Set Location to 5 60
            Set Label_Col_Offset to 52

            //AB-StoreStart
            set pbDataLoss to TRUE
            //AB-StoreEnd

        End_Object    // Jcreps_Idno

        Object oJCREPS_Division_Code is a cPTDbForm
            Entry_Item JCREPS.Division_Code
            Set Location to 5 141
            Set Size to 13 24
            Set Label to "Division:"
            Set Label_Col_Offset to 2
            Set Label_Justification_Mode to JMode_Right
            Set Prompt_Button_Mode to PB_PromptOn
        End_Object

        Object Jcreps_Pg_Phone is a dbForm
            Entry_Item Jcreps.Pg_phone
            Set Label to "External ID"
            Set Size to 13 56
            Set Location to 5 242
            Set Label_Col_Offset to 2
            Set Capslock_State to True
            Set Label_Justification_Mode to JMode_Right
            procedure Refresh integer iMode
                Boolean bAdmin
                Get pbAdmin    to bAdmin
                Set Enabled_State to (bAdmin and Jcreps.Pg_Phone = '')
                Forward Send Refresh iMode
            End_Procedure

        End_Object    // Jcreps_Pg_Phone

        Object Jcreps_Lastname is a cPTDbForm
            Entry_Item Jcreps.Lastname
            Set Label to "Last, First MI:"
            Set Size to 13 138
            Set Location to 20 60
            Set Label_Col_Offset to 52

            //AB-StoreStart
            set pbDataLoss to TRUE
            //AB-StoreEnd

        End_Object    // Jcreps_Lastname

        Object Jcreps_Firstname is a dbForm
            Entry_Item Jcreps.Firstname
            Set Size to 13 96
            Set Location to 20 202
            Set Label_Col_Offset to 2
            Set Label_Justification_Mode to jMode_Right
        End_Object    // Jcreps_Firstname

        Object Jcreps_Mi is a dbForm
            Entry_Item Jcreps.Mi
            Set Size to 13 13
            Set Location to 20 303
            Set Label_Col_Offset to 2
            Set Label_Justification_Mode to jMode_Right
        End_Object    // Jcreps_Mi

        Object Jcreps_Count is a dbForm
            Entry_Item Jcreps.Count
            Set Label to "Customers:"
            Set Size to 13 30
            Set Location to 34 60
            Set Label_Col_Offset to 52
        End_Object    // Jcreps_Count

        Object Jcreps_Csr_Assigned is a dbForm
            Entry_Item Jcreps.Csr_assigned
            Set Label to "Assigned CSR:"
            Set Size to 13 27
            Set Location to 50 60
            Set Label_Col_Offset to 52
        End_Object    // Jcreps_Csr_Assigned

    End_Object    // Container1

    Object dbTabDialog1 is a dbTabDialog
        Set Size to 188 468
        Set Location to 81 5
        Set Rotate_Mode to RM_Rotate
        Set peAnchors to anAll
        Set piMinSize to 114 340
        Object TP_Address is a dbTabPage
            Set Label to "Address"
            Object Jcreps_Address_1 is a dbForm
                Entry_Item Jcreps.Address_1
                Set Label to "Address:"
                Set Size to 13 246
                Set Location to 5 60
                Set Label_Col_Offset to 52
            End_Object    // Jcreps_Address_1

            Object Jcreps_Address_2 is a dbForm
                Entry_Item Jcreps.Address_2
                Set Size to 13 246
                Set Location to 20 60
                Set Label_Col_Offset to 52
            End_Object    // Jcreps_Address_2

            Object Jcreps_City is a dbForm
                Entry_Item Jcreps.City
                Set Label to "City ST  Zip:"
                Set Size to 13 126
                Set Location to 35 60
                Set Label_Col_Offset to 52
            End_Object    // Jcreps_City

            Object Jcreps_State is a dbForm
                Entry_Item Jcreps.State
                Set Size to 13 20
                Set Location to 35 191
                Set Label_Col_Offset to 2
                Set Label_Justification_Mode to jMode_Right
            End_Object    // Jcreps_State

            Object Jcreps_Zip is a dbForm
                Entry_Item Jcreps.Zip
                Set Size to 13 66
                Set Location to 35 222
                Set Label_Col_Offset to 2
                Set Label_Justification_Mode to jMode_Right
            End_Object    // Jcreps_Zip

            Object Jcreps_Hm_Phone is a dbForm
                Entry_Item Jcreps.Hm_phone
                Set Label to "Home Phone:"
                Set Size to 13 66
                Set Location to 50 60
                Set Label_Col_Offset to 52
            End_Object    // Jcreps_Hm_Phone

            Object Jcreps_Mo_Phone is a dbForm
                Entry_Item Jcreps.Mo_phone
                Set Label to "Mobile Phone:"
                Set Size to 13 66
                Set Location to 65 60
                Set Label_Col_Offset to 52
            End_Object    // Jcreps_Mo_Phone

            Object oJcreps_Email is a cPTDbForm
                Entry_Item Jcreps.Email
                Set Label to "E-Mail:"
                Set Size to 13 155
                Set Location to 65 175
                Set Label_Col_Offset to 2
                Set Label_Justification_Mode to jMode_Right
            End_Object    // oJcreps_Email

            Object oJcreps_Csr_Email is a cPTDbForm
                Entry_Item Jcreps.Csr_email
                Set Label to "CSR's Email:"
                Set Size to 13 155
                Set Location to 80 175
                Set Label_Col_Offset to 2
                Set Label_Justification_Mode to jMode_Right
            End_Object    // oJcreps_Csr_Email

        End_Object    // TP_Address

        Object TP_Personal is a dbTabPage
            Set Label to "Personal"
            Object Jcreps_Ssn is a dbForm
                Entry_Item Jcreps.Ssn
                Set Label to "SSN:"
                Set Size to 13 72
                Set Location to 5 60
                Set Label_Col_Offset to 52
            End_Object    // Jcreps_Ssn

            Object Jcreps_Birth is a dbForm
                Entry_Item Jcreps.Birth
                Set Label to "Date of birth:"
                Set Size to 13 66
                Set Location to 20 60
                Set Label_Col_Offset to 52
            End_Object    // Jcreps_Birth

            Object Jcreps_Date_Hired is a dbForm
                Entry_Item Jcreps.Date_hired
                Set Label to "Date hired:"
                Set Size to 13 66
                Set Location to 35 60
                Set Label_Col_Offset to 52
            End_Object    // Jcreps_Date_Hired

            Object Jcreps_Salary is a dbForm
                Entry_Item Jcreps.Salary
                Set Label to "Salary:"
                Set Size to 13 54
                Set Location to 50 60
                Set Label_Col_Offset to 52
            End_Object    // Jcreps_Salary

            Object Jcreps_Commission is a dbForm
                Entry_Item Jcreps.Commission
                Set Label to "Commission %:"
                Set Size to 13 30
                Set Location to 65 60
                Set Label_Col_Offset to 52
            End_Object    // Jcreps_Commission

            Object Jcreps_Payroll_Code is a dbForm
                Entry_Item Jcreps.Payroll_code
                Set Label to "Payroll Code:"
                Set Size to 13 18
                Set Location to 80 60
                Set Label_Col_Offset to 52
            End_Object    // Jcreps_Payroll_Code

        End_Object    // TP_Personal

        Object tp_SalesGoals is a dbTabPage
            Set Label to "Sales Goals"

            Object oJCREPS_Goal_1 is a cPTDbForm
                Entry_Item JCREPS.Goal_1
                Set Location to 10 32
                Set Size to 13 45
                Set Label to "Jan."
                Set Label_Col_Offset to 18
                Procedure OnChange
                    Send RefreshGoals
                End_Procedure
            End_Object

            Object oJCREPS_Goal_2 is a cPTDbForm
                Entry_Item JCREPS.Goal_2
                Set Location to 25 32
                Set Size to 13 45
                Set Label to "Feb."
                Set Label_Col_Offset to 18
                Procedure OnChange
                    Send RefreshGoals
                End_Procedure
            End_Object
            Object oJCREPS_Goal_3 is a cPTDbForm
                Entry_Item JCREPS.Goal_3
                Set Location to 40 32
                Set Size to 13 45
                Set Label to "Mar."
                Set Label_Col_Offset to 18
                Procedure OnChange
                    Send RefreshGoals
                End_Procedure
            End_Object
            Object oJCREPS_Goal_4 is a cPTDbForm
                Entry_Item JCREPS.Goal_4
                Set Location to 10 102
                Set Size to 13 45
                Set Label to "Apr."
                Set Label_Col_Offset to 18
                Procedure OnChange
                    Send RefreshGoals
                End_Procedure
            End_Object

            Object oJCREPS_Goal_5 is a cPTDbForm
                Entry_Item JCREPS.Goal_5
                Set Location to 25 102
                Set Size to 13 45
                Set Label to "May"
                Set Label_Col_Offset to 18
                Procedure OnChange
                    Send RefreshGoals
                End_Procedure
            End_Object
            Object oJCREPS_Goal_6 is a cPTDbForm
                Entry_Item JCREPS.Goal_6
                Set Location to 40 102
                Set Size to 13 45
                Set Label to "Jun."
                Set Label_Col_Offset to 18
                Procedure OnChange
                    Send RefreshGoals
                End_Procedure
            End_Object

            Object oJCREPS_Goal_7 is a cPTDbForm
                Entry_Item JCREPS.Goal_7
                Set Location to 10 172
                Set Size to 13 45
                Set Label to "Jul."
                Set Label_Col_Offset to 18
                Procedure OnChange
                    Send RefreshGoals
                End_Procedure
            End_Object
            Object oJCREPS_Goal_8 is a cPTDbForm
                Entry_Item JCREPS.Goal_8
                Set Location to 25 172
                Set Size to 13 45
                Set Label to "Aug."
                Set Label_Col_Offset to 18
                Procedure OnChange
                    Send RefreshGoals
                End_Procedure
            End_Object
            Object oJCREPS_Goal_9 is a cPTDbForm
                Entry_Item JCREPS.Goal_9
                Set Location to 40 172
                Set Size to 13 45
                Set Label to "Sep."
                Set Label_Col_Offset to 18
                Procedure OnChange
                    Send RefreshGoals
                End_Procedure
            End_Object

            Object oJCREPS_Goal_10 is a cPTDbForm
                Entry_Item JCREPS.Goal_10
                Set Location to 10 242
                Set Size to 13 45
                Set Label to "Oct."
                Set Label_Col_Offset to 18
                Procedure OnChange
                    Send RefreshGoals
                End_Procedure
            End_Object
            Object oJCREPS_Goal_11 is a cPTDbForm
                Entry_Item JCREPS.Goal_11
                Set Location to 25 242
                Set Size to 13 45
                Set Label to "Nov."
                Set Label_Col_Offset to 18
                Procedure OnChange
                    Send RefreshGoals
                End_Procedure
            End_Object
            Object oJCREPS_Goal_12 is a cPTDbForm
                Entry_Item JCREPS.Goal_12
                Set Location to 40 242
                Set Size to 13 45
                Set Label to "Dec."
                Set Label_Col_Offset to 18
                Procedure OnChange
                    Send RefreshGoals
                End_Procedure
            End_Object

            Object oQ1Goal is a Form
                Set Size to 13 45
                Set Location to 60 32
                Set Label to "Q1"
                Set Label_Col_Offset to 18
                Set Form_Datatype to Mask_Numeric_Window
                Set Form_Mask to "*,."
                Set Focus_Mode to NonFocusable
                Set Color to 10944511
                Procedure RefreshQtrGoal
                        Integer hJcrepsDD 
                        Number nG1 nG2 nG3 
                        Move (Jcreps_DD(Self)) to hJcrepsDD
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_1 to nG1
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_2 to nG2
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_3 to nG3
                        Set Value item 0 to (nG1 +nG2 +nG3)
                End_Procedure
            End_Object
            Object oQ2Goal is a Form
                Set Size to 13 45
                Set Location to 60 102
                Set Label to "Q2"
                Set Label_Col_Offset to 18
                Set Form_Datatype to Mask_Numeric_Window
                Set Form_Mask to "*,."
                Set Focus_Mode to NonFocusable
                Set Color to 10944511
                Procedure RefreshQtrGoal
                        Integer hJcrepsDD 
                        Number nG1 nG2 nG3 
                        Move (Jcreps_DD(Self)) to hJcrepsDD
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_4 to nG1
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_5 to nG2
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_6 to nG3
                        Set Value item 0 to (nG1 +nG2 +nG3)
                End_Procedure
            End_Object
            Object oQ3Goal is a Form
                Set Size to 13 45
                Set Location to 60 172
                Set Label to "Q3"
                Set Label_Col_Offset to 18
                Set Form_Datatype to Mask_Numeric_Window
                Set Form_Mask to "*,."
                Set Focus_Mode to NonFocusable
                Set Color to 10944511
                Procedure RefreshQtrGoal
                        Integer hJcrepsDD 
                        Number nG1 nG2 nG3 
                        Move (Jcreps_DD(Self)) to hJcrepsDD
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_7 to nG1
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_8 to nG2
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_9 to nG3
                        Set Value item 0 to (nG1 +nG2 +nG3)
                End_Procedure
            End_Object
            Object oQ4Goal is a Form
                Set Size to 13 45
                Set Location to 60 242
                Set Label to "Q4"
                Set Label_Col_Offset to 18
                Set Form_Datatype to Mask_Numeric_Window
                Set Form_Mask to "*,."
                Set Focus_Mode to NonFocusable
                Set Color to 10944511
                Procedure RefreshQtrGoal
                        Integer hJcrepsDD 
                        Number nG1 nG2 nG3 
                        Move (Jcreps_DD(Self)) to hJcrepsDD
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_10 to nG1
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_11 to nG2
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_12 to nG3
                        Set Value item 0 to (nG1 +nG2 +nG3)
                End_Procedure
            End_Object

            Object oYearGoal is a Form
                Set Size to 13 45
                Set Location to 75 242
                Set Label to "Year"
                Set Label_Col_Offset to 18
                Set Form_Datatype to Mask_Numeric_Window
                Set Form_Mask to "*,."
                Set Focus_Mode to NonFocusable
                Set Color to 13172680
                Procedure RefreshAnnualGoal
                        Integer hJcrepsDD 
                        Number nG1 nG2 nG3 nG4 nG5 nG6 nG7 nG8 nG9 nG10 nG11 nG12 
                        Move (Jcreps_DD(Self)) to hJcrepsDD
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_1 to nG1
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_2 to nG2
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_3 to nG3
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_4 to nG4
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_5 to nG5
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_6 to nG6
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_7 to nG7
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_8 to nG8
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_9 to nG9
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_10 to nG10
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_11 to nG11
                        Get Field_Current_Value of hJcrepsDD Field Jcreps.Goal_12 to nG12
                        Set Value item 0 to (nG1 +nG2 +nG3 +nG4 +nG5 +nG6 +nG7 +nG8 +nG9 +nG10 +nG11 +nG12)
                End_Procedure
            End_Object

            Object oButton_Update_Goals is a Button
                Set Size to 14 100
                Set Location to 79 33
                Set Label to "Create/Update &Goals Table"
                Set Focus_Mode to Pointer_Only
                //
                Procedure Onclick
                    Send doUpdateSalesRepGoals
                End_Procedure
            End_Object

            On_Key Key_Alt+Key_G Send OnClick of oButton_Update_Goals

        End_Object
        
        Object tp_GoalHistory is a dbTabPage
            Set Label to "Goal History"
            Object oDbGrid1 is a dbGrid
                Set Size to 166 457
                Set Location to 4 3
                Set Auto_Save_State to False

                Begin_Row
                    Entry_Item Jcshst.Year
                    Entry_Item Jcshst.Division
                    Entry_Item Jcshst.Goal_1
                    Entry_Item Jcshst.Goal_2
                    Entry_Item Jcshst.Goal_3
                    Entry_Item Jcshst.Goal_4
                    Entry_Item Jcshst.Goal_5
                    Entry_Item Jcshst.Goal_6
                    Entry_Item Jcshst.Goal_7
                    Entry_Item Jcshst.Goal_8
                    Entry_Item Jcshst.Goal_9
                    Entry_Item Jcshst.Goal_10
                    Entry_Item Jcshst.Goal_11
                    Entry_Item Jcshst.Goal_12
                    Entry_Item (isGoalYTD(server(Self))))
                    Entry_Item (isSlsYTD(server(Self)))
                    Entry_Item (isGoalPctYTD(server(Self)))
                End_Row

                Set Main_File to Jcshst.File_number

                Set Server to Jcshst_DD

                Set Form_Width 0 to 24
                Set Header_Label 0 to "Year"
                Set Form_Width 1 to 20
                Set Header_Label 1 to "Div"
                Set Form_Width 2 to 40
                Set Header_Label 2 to "Jan."
                Set Form_Width 3 to 40
                Set Header_Label 3 to "Feb."
                Set Form_Width 4 to 40
                Set Header_Label 4 to "Mar."
                Set Form_Width 5 to 40
                Set Header_Label 5 to "Apr."
                Set Form_Width 6 to 40
                Set Header_Label 6 to "May"
                Set Form_Width 7 to 40
                Set Header_Label 7 to "June"
                Set Form_Width 8 to 40
                Set Header_Label 8 to "July"
                Set Form_Width 9 to 40
                Set Header_Label 9 to "Aug."
                Set Form_Width 10 to 40
                Set Header_Label 10 to "Sep."
                Set Form_Width 11 to 40
                Set Header_Label 11 to "Oct."
                Set Form_Width 12 to 40
                Set Header_Label 12 to "Nov."
                Set Form_Width 13 to 40
                Set Header_Label 13 to "Dec."
                Set Header_Label 14 to "Y.T.D."
                Set Form_Width 14 to 40
                Set Header_Label 15 to "Sales"
                Set Form_Width 15 to 40
                Set Header_Label 16 to "% Goal"
                Set Form_Width 16 to 40

                Set Form_DataType 14 to mask_numeric_window 
                Set Form_Mask 14 to "########,."
                Set Form_DataType 15 to mask_numeric_window 
                Set Form_Mask 15 to "########,."
                Set Form_DataType 16 to mask_numeric_window 
                Set Form_Mask 16 to "####,.##%"

                Set Child_Table_State to True
                Set Wrap_State to True
                Set No_Delete_State to True
                Set peAnchors to anAll
                Set piMinSize to 92 329
                Set peResizeColumn to rcNone
                Set Ordering to 1
                Set peDisabledTextColor to clGreen

                Procedure SyncHistoryDisplays Integer iRec
                    Integer hDD iCurRec
                    Get Current_Record to iCurRec
                    If (iRec = iCurRec) Procedure_Return
                    Move (Jcshst_DD(Self)) to hDD
                    Move iRec to Jcchst.Recnum
                    Send Find of hDD EQ 0
                    Send Refresh_Page FILL_FROM_CENTER
                End_Procedure
        
            End_Object
        End_Object

        Object tp_SalesHistory is a dbTabPage
            Set Label to "Sales History"
            Object odbList1 is a dbList
                Set Size to 166 457
                Set Location to 4 3

                Begin_Row
                    Entry_Item Jcshst.Year
                    Entry_Item Jcshst.Division
                    Entry_Item Jcshst.Sales_1
                    Entry_Item Jcshst.Sales_2
                    Entry_Item Jcshst.Sales_3
                    Entry_Item Jcshst.Sales_4
                    Entry_Item Jcshst.Sales_5
                    Entry_Item Jcshst.Sales_6
                    Entry_Item Jcshst.Sales_7
                    Entry_Item Jcshst.Sales_8
                    Entry_Item Jcshst.Sales_9
                    Entry_Item Jcshst.Sales_10
                    Entry_Item Jcshst.Sales_11
                    Entry_Item Jcshst.Sales_12
                    Entry_Item (isSlsYTD(server(Self)))
                    Entry_Item (isSlsCstPftPctYTD(server(Self)))
                    Entry_Item (isVAPctYTD(server(Self)))
                End_Row

                Set Main_File to Jcshst.File_number

                Set Server to Jcshst_DD

                Set Form_Width 0 to 24
                Set Header_Label 0 to "Year"
                Set Form_Width 1 to 20
                Set Header_Label 1 to "Div"
                Set Form_Width 2 to 40
                Set Header_Label 2 to "Jan."
                Set Form_Width 3 to 40
                Set Header_Label 3 to "Feb."
                Set Form_Width 4 to 40
                Set Header_Label 4 to "Mar."
                Set Form_Width 5 to 40
                Set Header_Label 5 to "Apr."
                Set Form_Width 6 to 40
                Set Header_Label 6 to "May"
                Set Form_Width 7 to 40
                Set Header_Label 7 to "June"
                Set Form_Width 8 to 40
                Set Header_Label 8 to "July"
                Set Form_Width 9 to 40
                Set Header_Label 9 to "Aug."
                Set Form_Width 10 to 40
                Set Header_Label 10 to "Sep."
                Set Form_Width 11 to 40
                Set Header_Label 11 to "Oct."
                Set Form_Width 12 to 40
                Set Header_Label 12 to "Nov."
                Set Form_Width 13 to 40
                Set Header_Label 13 to "Dec."
                Set Header_Label 14 to "Y.T.D."
                Set Form_Width 14 to 40
                Set Header_Label 15 to "slscstpft%"
                Set Form_Width 15 to 40
                Set Header_Label 16 to "V.A. %"
                Set Form_Width 16 to 40
                Set Form_DataType 14 to mask_numeric_window 
                Set Form_Mask 14 to "########,."
                Set Form_DataType 15 to mask_numeric_window 
                Set Form_Mask 15 to "####,.##%"
                Set Form_DataType 16 to mask_numeric_window 
                Set Form_Mask 16 to "####,.##%"

                Set GridLine_Mode to Grid_Visible_Both
                Set Move_Value_Out_State to False
                Set peAnchors to anAll
                Set piMinSize to 92 329
                Set peResizeColumn to rcNone
                Set Deferred_State to True
                Set Ordering to 1
                Set Auto_Index_State to False
                Set peDisabledTextColor to clGreen

                Procedure SyncHistoryDisplays Integer iRec
                    Integer hDD iCurRec
                    Get Current_Record to iCurRec
                    If (iRec = iCurRec) Procedure_Return
                    Move (Jcshst_DD(Self)) to hDD
                    Move iRec to Jcchst.Recnum
                    Send Find of hDD EQ 0
                    Send Refresh_Page FILL_FROM_CENTER
                End_Procedure
        
            End_Object
        End_Object

        Object tp_CostHistory is a dbTabPage
            Set Label to "Sales Cost History"
            Object odbList2 is a dbList
                Set Size to 166 457
                Set Location to 4 3

                Begin_Row
                    Entry_Item Jcshst.Year
                    Entry_Item Jcshst.Division
                    Entry_Item Jcshst.SlsCst_1
                    Entry_Item Jcshst.SlsCst_2
                    Entry_Item Jcshst.SlsCst_3
                    Entry_Item Jcshst.SlsCst_4
                    Entry_Item Jcshst.SlsCst_5
                    Entry_Item Jcshst.SlsCst_6
                    Entry_Item Jcshst.SlsCst_7
                    Entry_Item Jcshst.SlsCst_8
                    Entry_Item Jcshst.SlsCst_9
                    Entry_Item Jcshst.SlsCst_10
                    Entry_Item Jcshst.SlsCst_11
                    Entry_Item Jcshst.SlsCst_12
                    Entry_Item (isSlsCstYTD(server(Self)))
                    Entry_Item (isSlsYTD(server(Self)))
                    Entry_Item (isSlsCstPftPctYTD(server(Self)))
                End_Row

                Set Main_File to Jcshst.File_number

                Set Server to Jcshst_DD

                Set Form_Width 0 to 24
                Set Header_Label 0 to "Year"
                Set Form_Width 1 to 20
                Set Header_Label 1 to "Div"
                Set Form_Width 2 to 40
                Set Header_Label 2 to "Jan."
                Set Form_Width 3 to 40
                Set Header_Label 3 to "Feb."
                Set Form_Width 4 to 40
                Set Header_Label 4 to "Mar."
                Set Form_Width 5 to 40
                Set Header_Label 5 to "Apr."
                Set Form_Width 6 to 40
                Set Header_Label 6 to "May"
                Set Form_Width 7 to 40
                Set Header_Label 7 to "June"
                Set Form_Width 8 to 40
                Set Header_Label 8 to "July"
                Set Form_Width 9 to 40
                Set Header_Label 9 to "Aug."
                Set Form_Width 10 to 40
                Set Header_Label 10 to "Sep."
                Set Form_Width 11 to 40
                Set Header_Label 11 to "Oct."
                Set Form_Width 12 to 40
                Set Header_Label 12 to "Nov."
                Set Form_Width 13 to 40
                Set Header_Label 13 to "Dec."
                Set Header_Label 14 to "Y.T.D."
                Set Form_Width 14 to 40
                Set Header_Label 15 to "Sales"
                Set Form_Width 15 to 40
                Set Header_Label 16 to "Profit%"
                Set Form_Width 16 to 40
                Set Form_DataType 14 to mask_numeric_window 
                Set Form_Mask 14 to "########,."
                Set Form_DataType 15 to mask_numeric_window 
                Set Form_Mask 15 to "########,."
                Set Form_DataType 16 to mask_numeric_window 
                Set Form_Mask 16 to "####,.##%"
                Set GridLine_Mode to Grid_Visible_Both
                Set Move_Value_Out_State to False
                Set peAnchors to anAll
                Set piMinSize to 92 329
                Set peResizeColumn to rcNone
                Set Deferred_State to True
                Set Auto_Index_State to False
                Set Ordering to 1
                Set peDisabledTextColor to clGreen

                Procedure SyncHistoryDisplays Integer iRec
                    Integer hDD iCurRec
                    Get Current_Record to iCurRec
                    If (iRec = iCurRec) Procedure_Return
                    Move (Jcshst_DD(Self)) to hDD
                    Move iRec to Jcchst.Recnum
                    Send Find of hDD EQ 0
                    Send Refresh_Page FILL_FROM_CENTER
                End_Procedure
        
            End_Object
        End_Object

        Object tp_ValueHistory is a dbTabPage
            Set Label to "Value Added History"
            Object odbList3 is a dbList
                Set Size to 166 457
                Set Location to 4 3

                Begin_Row
                    Entry_Item Jcshst.Year
                    Entry_Item Jcshst.Division
                    Entry_Item (isPeriodVA(Server(Self),1))
                    Entry_Item (isPeriodVA(Server(Self),2))
                    Entry_Item (isPeriodVA(Server(Self),3))
                    Entry_Item (isPeriodVA(Server(Self),4))
                    Entry_Item (isPeriodVA(Server(Self),5))
                    Entry_Item (isPeriodVA(Server(Self),6))
                    Entry_Item (isPeriodVA(Server(Self),7))
                    Entry_Item (isPeriodVA(Server(Self),8))
                    Entry_Item (isPeriodVA(Server(Self),9))
                    Entry_Item (isPeriodVA(Server(Self),10))
                    Entry_Item (isPeriodVA(Server(Self),11))
                    Entry_Item (isPeriodVA(Server(Self),12))
                    Entry_Item (isVAYTD(server(Self)))
                    Entry_Item (isSlsYTD(server(Self)))
                    Entry_Item (isVAPctYTD(server(Self)))
                End_Row

                Set Main_File to Jcshst.File_number

                Set Server to Jcshst_DD

                Set Form_Width 0 to 24
                Set Header_Label 0 to "Year"
                Set Form_Width 1 to 20
                Set Header_Label 1 to "Div"
                Set Form_Width 2 to 40
                Set Header_Label 2 to "Jan."
                Set Form_Width 3 to 40
                Set Header_Label 3 to "Feb."
                Set Form_Width 4 to 40
                Set Header_Label 4 to "Mar."
                Set Form_Width 5 to 40
                Set Header_Label 5 to "Apr."
                Set Form_Width 6 to 40
                Set Header_Label 6 to "May"
                Set Form_Width 7 to 40
                Set Header_Label 7 to "June"
                Set Form_Width 8 to 40
                Set Header_Label 8 to "July"
                Set Form_Width 9 to 40
                Set Header_Label 9 to "Aug."
                Set Form_Width 10 to 40
                Set Header_Label 10 to "Sep."
                Set Form_Width 11 to 40
                Set Header_Label 11 to "Oct."
                Set Form_Width 12 to 40
                Set Header_Label 12 to "Nov."
                Set Form_Width 13 to 40
                Set Header_Label 13 to "Dec."
                Set Header_Label 14 to "Y.T.D."
                Set Form_Width 14 to 40
                Set Header_Label 15 to "Sales"
                Set Form_Width 15 to 40
                Set Header_Label 16 to "V.A.%"
                Set Form_Width 16 to 40
                Set Form_DataType 14 to mask_numeric_window 
                Set Form_Mask 14 to "########,."
                Set Form_DataType 15 to mask_numeric_window 
                Set Form_Mask 15 to "########,."
                Set Form_DataType 16 to mask_numeric_window 
                Set Form_Mask 16 to "####,.##%"

                Set Form_DataType 2 to mask_numeric_window
                Set Form_Mask 2 to "########,."
                Set Form_DataType 3 to mask_numeric_window
                Set Form_Mask 3 to "########,."
                Set Form_DataType 4 to mask_numeric_window
                Set Form_Mask 4 to "########,."
                Set Form_DataType 5 to mask_numeric_window
                Set Form_Mask 5 to "########,."
                Set Form_DataType 6 to mask_numeric_window
                Set Form_Mask 6 to "########,."
                Set Form_DataType 7 to mask_numeric_window
                Set Form_Mask 7 to "########,."
                Set Form_DataType 8 to mask_numeric_window
                Set Form_Mask 8 to "########,."
                Set Form_DataType 9 to mask_numeric_window
                Set Form_Mask 9 to "########,."
                Set Form_DataType 10 to mask_numeric_window
                Set Form_Mask 10 to "########,."
                Set Form_DataType 11 to mask_numeric_window
                Set Form_Mask 11 to "########,."
                Set Form_DataType 12 to mask_numeric_window
                Set Form_Mask 12 to "########,."
                Set Form_DataType 13 to mask_numeric_window
                Set Form_Mask 13 to "########,."

                Set GridLine_Mode to Grid_Visible_Both
                Set Move_Value_Out_State to False
                Set peAnchors to anAll
                Set piMinSize to 92 329
                Set peResizeColumn to rcNone
                Set Deferred_State to True
                Set Ordering to 1
                Set Auto_Index_State to False
                Set peDisabledTextColor to clGreen

                Procedure SyncHistoryDisplays Integer iRec
                    Integer hDD iCurRec
                    Get Current_Record to iCurRec
                    If (iRec = iCurRec) Procedure_Return
                    Move (Jcshst_DD(Self)) to hDD
                    Move iRec to Jcchst.Recnum
                    Send Find of hDD EQ 0
                    Send Refresh_Page FILL_FROM_CENTER
                End_Procedure
        
            End_Object
        End_Object

  //// DISD BEGIN //////////////////////////
        Object tp_Top10Accts is a dbTabPage
            Set Label to "Business Intelligence"
            Object oTop10_Intelligence is a cDynamicAiReport
                Set Size to 205 484
                Set Location to 5 5
                Set peAnchors to anAll
                // Dynamic AI properties
                Set peEdition  to "Server"
                Set psBasicUrl to "http://localhost/ai6"
                Set psUsername to "VPApplication"
                Set psPassword to "ppms2113"
                Set pbUseTicketAuthentication to False
                //Set psAuthKey to "VisualParadigmPrintMgtSystem"
                //Set psRunUsername to "VPApplication"
                Set psRepository to "DNMC"
                Set pbSingleFrame to False 
                Set psListStyle to 14 // 26 = std 01 style +Paradigm logo & hide navigation pane; 
   // REMEMBER TO SET THE REPORT ID !
                Set psReportId to "5116"
                
                Procedure RunTheReport
                    Boolean bIsCreated
                    Integer iRepId
                    Get IsComObjectCreated to bIsCreated
                    If (bIsCreated) Begin
                        Get Field_Current_Value of JCReps_DD Field Jcreps.Idno to iRepId
                        If (iRepID) Begin
                            Send ClearAllFilters
                            Send AddFilter "Entdate_FNC_201" "2012" "" False //False to show filter
                            Send AddFilter "Jcreps_Idno" (String(iRepId)) "" True //True to hide filter
                            Send RunDynamicAiReport
                        End
                        Else Begin
                            // Present a blank page if report is not run 
                            Send ComNavigate "about:blank" 0 0 0 0
                        End
                    End
                End_Procedure //RunTheReport
                
            End_Object // DAI Report
            //
        End_Object // Business Intelligence tabpage
  //// DISD End //////////////////////////
//
        Procedure Request_Switch_To_Tab Integer iPage Integer iMode
            Integer iRep iCurrentTab iSlsHstRec
            Get Current_Tab to iCurrentTab
            Move (Current_Record(Server(Self))) to iRep
            If (iRep=0 and (iPage = 3 or iPage = 4 or iPage = 5 or iPage = 6)) Begin
                Send Stop_Box "No sales rep. selected."
                Procedure_Return
            End
            If (Should_Save(Self) and (iPage = 3 or iPage = 4 or iPage = 5 or iPage = 6)) ;
                Send Request_Save
            If (iCurrentTab >= 3 and iCurrentTab <=6) Begin 
                If (iCurrentTab =3) Begin 
                    Get Current_Record of oDbGrid1 to iSlsHstRec
                    If not iSlsHstRec Break
                    Send SyncHistoryDisplays of odbList1 iSlsHstRec
                    Send SyncHistoryDisplays of odbList2 iSlsHstRec
                    Send SyncHistoryDisplays of odbList3 iSlsHstRec
                End
                If (iCurrentTab =4) Begin 
                    Get Current_Record of oDbList1 to iSlsHstRec
                    If not iSlsHstRec Break
                    Send SyncHistoryDisplays of odbList2 iSlsHstRec
                    Send SyncHistoryDisplays of odbList3 iSlsHstRec
                    Send SyncHistoryDisplays of odbGrid1 iSlsHstRec
                End
                If (iCurrentTab =5) Begin 
                    Get Current_Record of oDbList2 to iSlsHstRec
                    If not iSlsHstRec Break
                    Send SyncHistoryDisplays of odbList1 iSlsHstRec
                    Send SyncHistoryDisplays of odbList3 iSlsHstRec
                    Send SyncHistoryDisplays of odbGrid1 iSlsHstRec
                End
                If (iCurrentTab =6) Begin 
                    Get Current_Record of oDbList3 to iSlsHstRec
                    If not iSlsHstRec Break
                    Send SyncHistoryDisplays of odbList1 iSlsHstRec
                    Send SyncHistoryDisplays of odbList2 iSlsHstRec
                    Send SyncHistoryDisplays of odbGrid1 iSlsHstRec
                End
            End
            Forward Send Request_Switch_To_Tab iPage iMode
  //// DISD BEGIN  ///////////
            If (iPage =7) Begin 
                Send RunTheReport of oTop10_Intelligence
            End
  //// DISD END  //////////////
            //
        End_Procedure //Request_Switch_To_Tab

        Procedure RefreshGoals
            Broadcast Recursive Send RefreshQtrGoal
            Broadcast Recursive Send RefreshAnnualGoal
        End_Procedure

    End_Object    // dbTabDialog1


    //AB-StoreStart
    Procedure doUpdateSalesRepGoals
        DateTime dtNow
        Integer iYear eResponse
        If (not(pbAdmin(Self))) Procedure_Return
        //
        Move (CurrentDateTime())  to dtNow
        Move (DateGetYear(dtNow)) to iYear
        //
        Get YesNo_Box ("Create or update sales goal history for " * String(iYear) + "\n for all reps for their assigned division?") "" MBR_No to eResponse
        If (eResponse = MBR_No) Procedure_Return
        //
        Clear Jcreps
        Repeat
            Find GT Jcreps.Idno
            If (FindErr) Break
            If ((Jcreps.Goal_1 +Jcreps.Goal_2 +Jcreps.Goal_3 +Jcreps.Goal_4 ; 
                +Jcreps.Goal_5 +Jcreps.Goal_6 +Jcreps.Goal_7 +Jcreps.Goal_8 ; 
                +Jcreps.Goal_9 +Jcreps.Goal_10 +Jcreps.Goal_11 +Jcreps.Goal_12) >0) ; 
                Begin 
                    Clear Jcshst
                    Move Jcreps.Idno          to Jcshst.Rep_Id
                    Move iYear                to Jcshst.Year
                    Move Jcreps.Division_Code to Jcshst.Division
                    Find eq Jcshst.Rep_Id
                    If Found Reread Jcshst
                    Else Lock
                        Move Jcreps.Goal_1  to Jcshst.Goal_1
                        Move Jcreps.Goal_2  to Jcshst.Goal_2
                        Move Jcreps.Goal_3  to Jcshst.Goal_3
                        Move Jcreps.Goal_4  to Jcshst.Goal_4
                        Move Jcreps.Goal_5  to Jcshst.Goal_5
                        Move Jcreps.Goal_6  to Jcshst.Goal_6
                        Move Jcreps.Goal_7  to Jcshst.Goal_7
                        Move Jcreps.Goal_8  to Jcshst.Goal_8
                        Move Jcreps.Goal_9  to Jcshst.Goal_9
                        Move Jcreps.Goal_10 to Jcshst.Goal_10
                        Move Jcreps.Goal_11 to Jcshst.Goal_11
                        Move Jcreps.Goal_12 to Jcshst.Goal_12
                        SaveRecord Jcshst
                    Unlock
                End
        Loop
        Send Info_Box (String(iYear)*" sales rep. goals have been updated") 
        Clear Jcshst
        Send Refind_Records of Jcreps_DD
    End_Procedure

    On_Key Key_Alt+Key_1 Send SwitchToAddressTabPage
    on_key Key_Alt+Key_2 send SwitchToPersonalTabPage
    On_Key Key_Alt+Key_3 Send SwitchToSalesGoalsTabPage
    On_Key Key_Alt+Key_4 Send SwitchToGoalHistoryTabPage
    On_Key Key_Alt+Key_5 Send SwitchToSalesHistoryTabPage
    On_Key Key_Alt+Key_6 Send SwitchToCostHistoryTabPage
    On_Key Key_Alt+Key_7 Send SwitchToValueHistoryTabPage
    
    Procedure SwitchToAddressTabPage
        send Request_Switch_To_Tab of dbTabDialog1 0 3
    End_Procedure
    
    Procedure SwitchToPersonalTabPage
        send Request_Switch_To_Tab of dbTabDialog1 1 3
    End_Procedure

    Procedure SwitchToSalesGoalsTabPage
        Boolean bAdmin bMgr
        Get pbAdmin to bAdmin
        Get pbMgr to bMgr
        If not (bAdmin or bMgr) Procedure_Return
        Send Request_Switch_To_Tab of dbTabDialog1 2 3
    End_Procedure

    Procedure SwitchToGoalHistoryTabPage
        Boolean bAdmin bMgr
        Get pbAdmin to bAdmin
        Get pbMgr to bMgr
        If not (bAdmin or bMgr) Procedure_Return
        Send Request_Switch_To_Tab of dbTabDialog1 3 3
    End_Procedure

    Procedure SwitchToSalesHistoryTabPage
        Boolean bAdmin bMgr
        Get pbAdmin to bAdmin
        Get pbMgr to bMgr
        If not (bAdmin or bMgr) Procedure_Return
        Send Request_Switch_To_Tab of dbTabDialog1 4 3
    End_Procedure

    Procedure SwitchToCostHistoryTabPage
        Boolean bAdmin bMgr
        Get pbAdmin to bAdmin
        Get pbMgr to bMgr
        If not (bAdmin or bMgr) Procedure_Return
        Send Request_Switch_To_Tab of dbTabDialog1 5 3
    End_Procedure

    Procedure SwitchToValueHistoryTabPage
        Boolean bAdmin bMgr
        Get pbAdmin to bAdmin
        Get pbMgr to bMgr
        If not (bAdmin or bMgr) Procedure_Return
        Send Request_Switch_To_Tab of dbTabDialog1 6 3
    End_Procedure

    Procedure Activating
        Boolean bReadOnly bAdmin bMgr
        get pbAdmin    of ghoApplication to bAdmin
        Get pbMgr      of ghoApplication to bMgr
        Get pbReadonly of ghoApplication to bReadOnly
        set pbAdmin    to bAdmin
        Set pbMgr    to bMgr
        Set pbReadonly to bReadOnly
        set Read_Only_State of Jcreps_DD to bReadOnly
        if bReadOnly Set Label to "Sales Rep's - READ ONLY"
        else         Set Label to "Sales Rep's"
        Set Visible_State of tp_SalesGoals to (bAdmin or bMgr)
        Set Visible_State of tp_GoalHistory to (bAdmin or bMgr)
        Set Visible_State of tp_SalesHistory to (bAdmin or bMgr)
        Set Visible_State of tp_CostHistory to (bAdmin or bMgr)
        Set Visible_State of tp_ValueHistory to (bAdmin or bMgr)

        Forward Send activating
    End_Procedure
    //AB-StoreEnd

End_Object    // JCREPS

//AB/ End_Object    // prj

